#########################################################################################
# @copyright(disclaimer)                                                                #
# Licensed Materials - Property of IBM                                                  #
# IBM  Enterprise Information Portal for Multiplatforms V8.1  (program number 5724-B43) #
# (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                            #
#                                                                                       #
# US Government Users Restricted Rights                                                 #
# Use, duplication or disclosure restricted by GSA ADP Schedule                         #
# Contract with IBM Corp.                                                               #
#                                                                                       #
# DISCLAIMER OF WARRANTIES :                                                            #
#                                                                                       #
# Permission is granted to copy and modify this Sample code, and to                     #
# distribute modified versions provided that both the copyright                         #
# notice,- and this permission notice and warranty disclaimer appear                    #
# in all copies and modified versions.                                                  #
#                                                                                       #
# THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                            #
# IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR        #
# IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE      #
# IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO      #
# EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF #
# THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR   #
# COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS      #
# LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR  #
# DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER      #
# CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR   #
# SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                       #
#                                                                                       #
# @endCopyright                                                                         #
#########################################################################################
#########################################################################
#                                                                       #
#    Makefile for the TExecuteDJ                                   #
#                                                                       #
#########################################################################
CC= xlC_r
CCC= xlC_r

#------------------------------------------------------------------------
# Compiler options:
# -c			Compile only, don't link
# -g			Generate information for the xldb debugger
# -qinfo=all		Display all warning and informational messages
#	:nocpy		except copy contructor informationals
#	:nogen		except compiler generated variables informationals
#	:novft		except virtual function tables generated informationals
#
# -ro			Place string literals in read-only memory.
# -roconst		Place constants in read-only memory.
# -qproto		Call points must match function prototype.
# -qlanglvl=ansi	(.c) Set the language level to ANSI.
# -qcpluscmt		(.c) Allow C++ style comment in C code.
# -D_ALL_SOURCE		Needed to make all system prototypes visible
#
# -DAIX			Compiling on AIX.
# -DTOOLKIT		To use DJ Client Toolkit.
#
CFRNINST= /usr/lpp/cmb
#CDEBUG=	-g -DDEBUG
CDEBUG=
#CWARN= -qinfo=all:nocpy:nogen:novft
CCOMMON= -qdbcs -qro -qproto -qrtti=all -qnodigraph -D_ALL_SOURCE -DAIX -DTOOLKIT -DUSERAPP

CINCLUDES= -I. -I$(CFRNINST)/include

CFLAGS= $(CDEBUG) $(CCOMMON) $(CINCLUDES) -qlanglvl=ansi -qcpluscmt
CCFLAGS= $(CDEBUG) $(CCOMMON) $(CINCLUDES) -qroconst


#------------------------------------------------------------------------
# Linker options and libraries:
#
# -K			Pad output file to page boundary.
CLDFLAGS= -K $(CDEBUG)
CLIBPATHS= -L. -L$(CFRNINST)/lib

CLIBS= -lvacbase5 -lm -lcmbcm815 -lcmbdj815


.SUFFIXES:	.c .cpp

.c.o:
	rm -f $*.o
	$(CC) -c $< $(CFLAGS)

.cpp.o:
	rm -f $*.o
	$(CCC) -c -+ $< $(CCFLAGS)


#------------------------------------------------------------------------
# Targets for making OQS sample programs
#
TARGETS= TExecuteDJ

all: $(TARGETS)

clean:
	rm -f *.o $(TARGETS)

install: all
	@echo "	Nothing to install, done!"


TExecuteDJ.o: TExecuteDJ.cpp 

TExecuteDJ: TExecuteDJ.o
	rm -f $@
	$(CCC) -o $@ $*.o $(CLDFLAGS) $(CLIBPATHS) $(CLIBS)

