/*
@copyright(disclaimer)

Licensed Materials - Property of IBM
IBM  Enterprise Information Portal  for Multiplatforms V8.1  (program number 5724-B43)
(c) Copyright IBM Corp. 1998,  2002. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
*/

import com.ibm.mm.beans.*;

/**
 * Changes password on a server.
 */
public class TChangePassword
{
	public static void main(String args[]) throws Exception
	{
		if (args.length < 5) {
			System.out.print(
				"Changes password on a server. \n"
					+ "Syntax: \n"
					+ "  java TChangePassword <dstype> <server> <userid> <oldpassword> <newpassword> \n"
					+ "Examples: \n"
					+ "  java TChangePassword DL libsrvrn frnadmin password newpassword \n"
					+ "");
			System.exit(0);
		}
		
		// Read args
		String dstype = args[0];
		String server = args[1];
		String userid = args[2];
		String oldpassword = args[3];
		String newpassword = args[4];
		
		// Create beans
		CMBConnection connBean = new CMBConnection();

		// Connect to server
		System.out.println("Connecting to server");
		connBean.setDsType(dstype);
		connBean.setServerName(server);
		connBean.setUserid(userid);
		connBean.setPassword(oldpassword);
		connBean.connect();

		System.out.println("Performing change password");
		connBean.changePassword(newpassword);

		System.out.println("Disconnecting from server");
		connBean.disconnect();
	}
}
