/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;

// TConnectQBIC class
public class TConnectQBIC implements DKConstantDL {

  // Main method
  public static void main(String argv[]){
     // Indicate this is a Console Application on Windows NT/95 for error
     // message display in dos console code page. If this was a Windows
     // GUI (Graphic User Interface) Application this would not be necessary
     // because DK_CM_SS_WINDOWS is the default.
     DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

     //-------------------------------------------------------------- 
     // Checking for input parameters
     //-------------------------------------------------------------- 
   
     if (argv.length < 5){
        System.out.println("Usage: " );
        System.out.println("  java TConnectQBIC <qbicSrv> <userid> <pw> <qbicdb> <qbiccat> " );
        return;
     }
   
     String qbicSrv = argv[0];
     String userid  = argv[1];
     String pw      = argv[2];
     String qbicdb  = argv[3];
     String qbiccat = argv[4];
    
     DKDatastoreQBIC dsQBIC = null;
     try {
	     dsQBIC = new DKDatastoreQBIC();
	     String str;
	     
	     System.out.println("Datastore QBIC created");
	     System.out.println("connecting to datastore");
	     dsQBIC.connect(qbicSrv,userid,pw,"");
	     System.out.println("datastore connected");
	     if (dsQBIC.isConnected() == true)
	         System.out.println("connection is true ");
	     else
	         System.out.println("connection is false ");
   
    	 dsQBIC.openCatalog(qbicdb, qbiccat);
	     System.out.println("Catalog opened ");

	     str = dsQBIC.datastoreName();
	     System.out.println("QBIC datastore name is " + str);
	     str = dsQBIC.databaseName();
	     System.out.println("QBIC database name is " + str);
	     str = dsQBIC.catalogName();
	     System.out.println("QBIC catalog name is " + str);

    	 dsQBIC.closeCatalog();
	     System.out.println("Catalog closed");

	     dsQBIC.disconnect();
	     System.out.println("datastore disconnected");
	     dsQBIC.destroy();
     }
     catch(Exception exc){
     	 try {
     	     dsQBIC.destroy();
     	 }
     	 catch (Exception e)
     	 {
     	  e.printStackTrace();
     	 }         
         System.out.println("Exception message " + exc.getMessage());
         exc.printStackTrace();
     }
  }
}

