/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
                         
// sample to list workflows in WorkFlow/WorkBasket

/*
 * Filename : TListWorkFlowWFS.java
 * Description : List workflows in WorkFlow/WorkBasket
 *
 */
                              
import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;

public class TListWorkFlowWFS
        implements DKConstant, DKMessageId
{
  //replace following with your library server name, userid, pasword
  public static final String STR_LIB_SERVER  = "LIBSRVRN";
  public static final String STR_USER_ID     = "FRNADMIN";
  public static final String STR_PASSWORD    = "PASSWORD";

  // Main method
  public static void main(String argv[])
  {
    System.out.println("begin...");
    
    DKDatastoreDL dsDL = new DKDatastoreDL();
    try {
        dsDL = new DKDatastoreDL();
        DKWorkFlowServiceDL wfDL = new DKWorkFlowServiceDL(dsDL);
        System.out.println("Datastore DL created");
        System.out.println("connecting to datastore");
        dsDL.connect(STR_LIB_SERVER, STR_USER_ID, STR_PASSWORD, "");
        System.out.println("datastore connected");
	    if (wfDL.isConnected())
	        System.out.println("workflow service has been connected");
	    else
	        System.out.println("workflow service is not connected");

        System.out.println("");
        System.out.println("**************List of workflow");
        DKSequentialCollection wfList = (DKSequentialCollection)wfDL.listWorkFlows();
        if (wfList != null)
        {
            dkIterator pIter = wfList.createIterator();
            DKWorkFlowDL pwf1;
            System.out.println("There are " + wfList.cardinality() +
                                " wkrofkows defined in the system.");
            while (pIter.more())
            {
                pwf1 = (DKWorkFlowDL)pIter.next(); 
                System.out.println("Workflow ID = " + pwf1.getID());
                pwf1.retrieve();
                System.out.println("Workflow Name = " + pwf1.getName());
            }
        }

        System.out.println("");
        System.out.println("**************List of workflow id");
        DKSequentialCollection wfList2 = (DKSequentialCollection)wfDL.listWorkFlowIDs();
        if (wfList2 != null)
        {
            dkIterator pIter = wfList2.createIterator();
            String wf;
            System.out.println("There are " + wfList2.cardinality() +
                                " wkrofkows defined in the system.");
            while (pIter.more())
            {
                wf = (String)pIter.next(); 
                System.out.println("Workflow ID = " + wf);
            }
        }

        dsDL.disconnect();
        System.out.println("datastore disconnected");
        dsDL.destroy();
    }

    catch(DKException exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception id " + exc.exceptionId());
     System.out.println("Exception Class Name: " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     System.out.println("Exception error code " + exc.errorCode());
     System.out.println("Exception error state " + exc.errorState());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }

    System.out.println("done ...");
  } // end of main    
}
